--- a/ext/phar/tar.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/phar/tar.c	2025-10-25 03:24:13.168008940 +0000
@@ -1170,7 +1170,16 @@
 	}
 
 	zend_hash_apply_with_argument(&phar->manifest, phar_tar_writeheaders, (void *) &pass);
-	/* TODO: memory leak and incorrect continuation if phar_tar_writeheaders fails? */
+
+	if (error && *error) {
+		if (must_close_old_file) {
+			php_stream_close(oldfile);
+		}
+
+		/* on error in the hash iterator above, error is set */
+		php_stream_close(newfile);
+		return;
+	}
 
 	/* add signature for executable tars or tars explicitly set with setSignatureAlgorithm */
 	if (!phar->is_data || phar->sig_flags) {
diff '--color=auto' -Naur a/ext/phar/tests/tar_flush_too_long_filename.phpt b/ext/phar/tests/tar_flush_too_long_filename.phpt
--- a/ext/phar/tests/tar_flush_too_long_filename.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/phar/tests/tar_flush_too_long_filename.phpt	2025-10-25 03:24:13.168242583 +0000
@@ -0,0 +1,41 @@
+--TEST--
+Tar flush with too long file name
+--EXTENSIONS--
+phar
+--SKIPIF--
+<?php
+if (getenv('SKIP_SLOW_TESTS')) die('skip');
+if (function_exists('openssl_sign')) die('skip requires openssl disabled for mocking purposes');
+?>
+--INI--
+phar.require_hash=0
+--FILE--
+<?php
+$fname = __DIR__ . '/' . basename(__FILE__, '.php') . '.tar';
+
+// Mock sign to fail at second invocation, tricks failure in phar_create_signature()
+function openssl_sign() {
+    static $counter = 0;
+    $counter++;
+    if ($counter === 2) {
+        return false;
+    }
+    return true;
+}
+
+$phar = new PharData($fname);
+$phar->addEmptyDir('blah1/');
+$phar->setSignatureAlgorithm(Phar::OPENSSL, "randomcrap");
+try {
+    $phar->addEmptyDir('blah2/' . str_repeat('X', 1000));
+} catch (PharException $e) {
+    echo $e->getMessage();
+}
+
+?>
+--CLEAN--
+<?php
+unlink(__DIR__ . '/' . basename(__FILE__, '.clean.php') . '.tar');
+?>
+--EXPECTF--
+tar-based phar "%s" cannot be created, filename "%s" is too long for tar file format
diff '--color=auto' -Naur a/ext/phar/zip.c b/ext/phar/zip.c
--- a/ext/phar/zip.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/phar/zip.c	2025-10-25 03:24:13.168422504 +0000
@@ -1223,7 +1223,9 @@
 		entry.fp_type = PHAR_MOD;
 		entry.is_modified = 1;
 		if (entry.fp == NULL) {
+			efree(signature);
 			spprintf(pass->error, 0, "phar error: unable to create temporary file for signature");
+			php_stream_close(newfile);
 			return FAILURE;
 		}
 
@@ -1441,11 +1443,12 @@
 
 	phar_metadata_tracker_try_ensure_has_serialized_data(&phar->metadata_tracker, phar->is_persistent);
 	if (temperr) {
+temperror:
 		if (error) {
 			spprintf(error, 4096, "phar zip flush of \"%s\" failed: %s", phar->fname, temperr);
 		}
 		efree(temperr);
-temperror:
+notemperror:
 		php_stream_close(pass.centralfp);
 nocentralerror:
 		php_stream_close(pass.filefp);
@@ -1473,7 +1476,7 @@
 			if (error) {
 				spprintf(error, 4096, "phar zip flush of \"%s\" failed: unable to write central-directory", phar->fname);
 			}
-			goto temperror;
+			goto notemperror;
 		}
 	}
 
diff '--color=auto' -Naur a/ext/random/tests/03_randomizer/gh_19765_unserialize.phpt b/ext/random/tests/03_randomizer/gh_19765_unserialize.phpt
--- a/ext/random/tests/03_randomizer/gh_19765_unserialize.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/random/tests/03_randomizer/gh_19765_unserialize.phpt	2025-10-25 03:24:13.168706004 +0000
@@ -0,0 +1,21 @@
+--TEST--
+GH-19765: object_properties_load() bypasses readonly property checks
+--FILE--
+<?php
+
+use Random\Engine\Mt19937;
+use Random\Engine\PcgOneseq128XslRr64;
+use Random\Randomizer;
+
+try {
+    $r = new Randomizer(new Mt19937());
+    $r->__unserialize([['engine' => new PcgOneseq128XslRr64()]]);
+} catch (Exception $error) {
+    echo $error->getMessage() . "\n";
+}
+var_dump($r->engine::class);
+
+?>
+--EXPECT--
+Invalid serialization data for Random\Randomizer object
+string(21) "Random\Engine\Mt19937"
diff '--color=auto' -Naur a/ext/random/tests/03_randomizer/gh_9186_unserialize.phpt b/ext/random/tests/03_randomizer/gh_9186_unserialize.phpt
--- a/ext/random/tests/03_randomizer/gh_9186_unserialize.phpt	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/random/tests/03_randomizer/gh_9186_unserialize.phpt	2025-10-25 03:24:13.168802169 +0000
@@ -1,5 +1,5 @@
 --TEST--
-Fix GH-9186 @strict-properties can be bypassed using unserialization
+GH-9186: @strict-properties can be bypassed using unserialization
 --FILE--
 <?php
 
diff '--color=auto' -Naur a/ext/simplexml/simplexml.c b/ext/simplexml/simplexml.c
--- a/ext/simplexml/simplexml.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/simplexml/simplexml.c	2025-10-25 03:24:13.169043185 +0000
@@ -1529,10 +1529,10 @@
 				/* Attributes in the xmlns namespace should be treated as namespace declarations too. */
 				if (attr->ns && xmlStrEqual(attr->ns->href, (const xmlChar *) "http://www.w3.org/2000/xmlns/")) {
 					const char *prefix = attr->ns->prefix ? (const char *) attr->name : "";
-					bool free;
-					xmlChar *href = php_libxml_attr_value(attr, &free);
+					bool should_free;
+					xmlChar *href = php_libxml_attr_value(attr, &should_free);
 					sxe_add_namespace_name_raw(return_value, prefix, (const char *) href);
-					if (free) {
+					if (should_free) {
 						xmlFree(href);
 					}
 				}
@@ -1629,7 +1629,7 @@
 	node = php_sxe_get_first_node_non_destructive(sxe, node);
 	if (node) {
 		namelen = xmlStrlen(node->name);
-		RETURN_STRINGL((char*)node->name, namelen);
+		RETURN_STRINGL_FAST((const char *) node->name, namelen);
 	} else {
 		RETURN_EMPTY_STRING();
 	}
diff '--color=auto' -Naur a/ext/soap/php_encoding.c b/ext/soap/php_encoding.c
--- a/ext/soap/php_encoding.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/soap/php_encoding.c	2025-10-25 03:24:13.169568146 +0000
@@ -3610,6 +3610,11 @@
 				soap_error0(E_ERROR,  "Encoding: SoapVar has no 'enc_type' property");
 			}
 			cur_type = Z_LVAL_P(ztype);
+			if (cur_type == UNKNOWN_TYPE) {
+				/* Mimic guess_xml_convert() where we use the type of the data.
+				 * UNDEFs are handled transparently as it will error out upon encoding the data. */
+				cur_type = Z_TYPE_P(Z_VAR_ENC_VALUE_P(tmp));
+			}
 
 			zval *zstype = Z_VAR_ENC_STYPE_P(tmp);
 			if (Z_TYPE_P(zstype) == IS_STRING) {
diff '--color=auto' -Naur a/ext/soap/soap.c b/ext/soap/soap.c
--- a/ext/soap/soap.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/soap/soap.c	2025-10-25 03:24:13.170229616 +0000
@@ -1002,7 +1002,13 @@
 	service->soap_functions.ft = zend_new_array(0);
 
 	if (wsdl) {
-		service->sdl = get_sdl(ZEND_THIS, ZSTR_VAL(wsdl), cache_wsdl);
+		zend_try {
+			service->sdl = get_sdl(ZEND_THIS, ZSTR_VAL(wsdl), cache_wsdl);
+		} zend_catch {
+			xmlCharEncCloseFunc(service->encoding);
+			service->encoding = NULL;
+			zend_bailout();
+		} zend_end_try();
 		if (service->uri == NULL) {
 			if (service->sdl->target_ns) {
 				service->uri = estrdup(service->sdl->target_ns);
diff '--color=auto' -Naur a/ext/soap/tests/bugs/gh19784.phpt b/ext/soap/tests/bugs/gh19784.phpt
--- a/ext/soap/tests/bugs/gh19784.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/soap/tests/bugs/gh19784.phpt	2025-10-25 03:24:13.170742714 +0000
@@ -0,0 +1,14 @@
+--TEST--
+GH-19784 (SoapServer memory leak)
+--EXTENSIONS--
+soap
+--FILE--
+<?php
+$v_5256 = 'zpHOks6TzpTOlc6WzpfOmM6ZzprOm86czp3Ons6fzqDOoc6jzqTOpc6mzqfOqM6p';
+$v_5257 = base64_decode($v_5256,);
+$v_5238 = array('encoding' => $v_5257);
+new SoapServer('foobarbaz',$v_5238,);
+?>
+--EXPECTF--
+<?xml version="1.0" encoding="UTF-8"?>
+<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body><SOAP-ENV:Fault><faultcode>%s</faultcode><faultstring>%a
diff '--color=auto' -Naur a/ext/soap/tests/bugs/gh20011.phpt b/ext/soap/tests/bugs/gh20011.phpt
--- a/ext/soap/tests/bugs/gh20011.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/soap/tests/bugs/gh20011.phpt	2025-10-25 03:24:13.170821047 +0000
@@ -0,0 +1,20 @@
+--TEST--
+GH-20011 (Array of SoapVar of unknown type causes crash)
+--EXTENSIONS--
+soap
+--FILE--
+<?php
+class TestSoapClient extends SoapClient {
+    public function __doRequest($request, $location, $action, $version, $one_way = false): ?string {
+        die($request);
+    }
+}
+
+$array = [new SoapVar('test string', NULL)];
+
+$client = new TestSoapClient(NULL, ['location' => 'test://', 'uri' => 'http://soapinterop.org/']);
+$client->echoStringArray($array);
+?>
+--EXPECT--
+<?xml version="1.0" encoding="UTF-8"?>
+<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ns1="http://soapinterop.org/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><SOAP-ENV:Body><ns1:echoStringArray><param0 SOAP-ENC:arrayType="xsd:string[1]" xsi:type="SOAP-ENC:Array"><item xsi:type="xsd:string">test string</item></param0></ns1:echoStringArray></SOAP-ENV:Body></SOAP-ENV:Envelope>
diff '--color=auto' -Naur a/ext/standard/array.c b/ext/standard/array.c
--- a/ext/standard/array.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/standard/array.c	2025-10-25 03:24:13.171299279 +0000
@@ -3497,6 +3497,12 @@
 	HT_SET_ITERATORS_COUNT(in_hash, 0);
 	in_hash->pDestructor = NULL;
 
+	/* Set internal pointer to 0 directly instead of calling zend_hash_internal_pointer_reset().
+	 * This avoids the COW violation assertion and delays advancing to the first valid position
+	 * until after we've switched to the new array structure (out_hash). The iterator will be
+	 * advanced when actually accessed, at which point it will find valid indexes in the new array. */
+	in_hash->nInternalPointer = 0;
+
 	if (UNEXPECTED(GC_DELREF(in_hash) == 0)) {
 		/* Array was completely deallocated during the operation */
 		zend_array_destroy(in_hash);
@@ -3515,8 +3521,6 @@
 	in_hash->nNextFreeElement  = out_hash.nNextFreeElement;
 	in_hash->arData            = out_hash.arData;
 	in_hash->pDestructor       = out_hash.pDestructor;
-
-	zend_hash_internal_pointer_reset(in_hash);
 }
 /* }}} */
 
@@ -5027,6 +5031,11 @@
 	ZVAL_UNDEF(&arTmp[i].b.val);
 	zend_sort((void *) arTmp, i, sizeof(struct bucketindex),
 			(compare_func_t) cmp, (swap_func_t) array_bucketindex_swap);
+
+	if (UNEXPECTED(EG(exception))) {
+		goto out;
+	}
+
 	/* go through the sorted array and delete duplicates from the copy */
 	lastkept = arTmp;
 	for (cmpdata = arTmp + 1; Z_TYPE(cmpdata->b.val) != IS_UNDEF; cmpdata++) {
@@ -5046,6 +5055,8 @@
 			}
 		}
 	}
+
+out:
 	pefree(arTmp, GC_FLAGS(Z_ARRVAL_P(array)) & IS_ARRAY_PERSISTENT);
 
 	if (in_place) {
diff '--color=auto' -Naur a/ext/standard/basic_functions.c b/ext/standard/basic_functions.c
--- a/ext/standard/basic_functions.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/standard/basic_functions.c	2025-10-25 03:24:13.171799144 +0000
@@ -2015,10 +2015,8 @@
 #define _CHECK_PATH(var, var_len, ini) php_ini_check_path(var, var_len, ini, sizeof(ini))
 	/* open basedir check */
 	if (PG(open_basedir)) {
-		if (_CHECK_PATH(ZSTR_VAL(varname), ZSTR_LEN(varname), "error_log") ||
-			_CHECK_PATH(ZSTR_VAL(varname), ZSTR_LEN(varname), "java.class.path") ||
+		if (_CHECK_PATH(ZSTR_VAL(varname), ZSTR_LEN(varname), "java.class.path") ||
 			_CHECK_PATH(ZSTR_VAL(varname), ZSTR_LEN(varname), "java.home") ||
-			_CHECK_PATH(ZSTR_VAL(varname), ZSTR_LEN(varname), "mail.log") ||
 			_CHECK_PATH(ZSTR_VAL(varname), ZSTR_LEN(varname), "java.library.path") ||
 			_CHECK_PATH(ZSTR_VAL(varname), ZSTR_LEN(varname), "vpopmail.directory")) {
 			if (php_check_open_basedir(ZSTR_VAL(new_value_str))) {
diff '--color=auto' -Naur a/ext/standard/tests/array/gh19926.phpt b/ext/standard/tests/array/gh19926.phpt
--- a/ext/standard/tests/array/gh19926.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/array/gh19926.phpt	2025-10-25 03:24:13.172022905 +0000
@@ -0,0 +1,20 @@
+--TEST--
+GH-19926 (Assertion failure zend_hash_internal_pointer_reset_ex)
+--FILE--
+<?php
+class ThrowingDestructor {
+    function __destruct() {
+        throw new Exception();
+    }
+}
+
+$arr = [new ThrowingDestructor(), new ThrowingDestructor()];
+
+try {
+    array_splice($arr, 0, 2);
+} catch (Exception $e) {
+    echo "Exception caught, no assertion failure\n";
+}
+?>
+--EXPECT--
+Exception caught, no assertion failure
diff '--color=auto' -Naur a/ext/standard/tests/array/gh19926_pointer.phpt b/ext/standard/tests/array/gh19926_pointer.phpt
--- a/ext/standard/tests/array/gh19926_pointer.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/array/gh19926_pointer.phpt	2025-10-25 03:24:13.172099107 +0000
@@ -0,0 +1,19 @@
+--TEST--
+GH-19926 (internal pointer behavior after array_splice)
+--FILE--
+<?php
+$a = [1, 2, 3];
+unset($a[0]);
+next($a);
+
+echo "Before array_splice: ";
+var_dump(current($a));
+
+array_splice($a, 0, 0, [999]);
+
+echo "After array_splice: ";
+var_dump(current($a));
+?>
+--EXPECT--
+Before array_splice: int(3)
+After array_splice: int(999)
diff '--color=auto' -Naur a/ext/standard/tests/array/gh20043.phpt b/ext/standard/tests/array/gh20043.phpt
--- a/ext/standard/tests/array/gh20043.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/array/gh20043.phpt	2025-10-25 03:24:13.172196018 +0000
@@ -0,0 +1,12 @@
+--TEST--
+GH-20043 (array_unique assertion failure with RC1 array causing an exception on sort)
+--FILE--
+<?php
+try {
+	array_unique([new stdClass, new stdClass], SORT_STRING | SORT_FLAG_CASE);
+} catch (Error $e) {
+	echo $e->getMessage();
+}
+?>
+--EXPECT--
+Object of class stdClass could not be converted to string
diff '--color=auto' -Naur a/ext/standard/tests/file/bug46347.phpt b/ext/standard/tests/file/bug46347.phpt
--- a/ext/standard/tests/file/bug46347.phpt	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/standard/tests/file/bug46347.phpt	2025-10-25 03:24:13.172340112 +0000
@@ -8,14 +8,14 @@
 part1.*.part2 = 1
 EOF;
 
-$file = __DIR__ . '/parse.ini';
+$file = __DIR__ . '/bug46347.ini';
 file_put_contents($file, $str);
 
 var_dump(parse_ini_file($file));
 ?>
 --CLEAN--
 <?php
-unlink(__DIR__.'/parse.ini');
+unlink(__DIR__.'/bug46347.ini');
 ?>
 --EXPECT--
 array(1) {
diff '--color=auto' -Naur a/ext/standard/tests/filters/convert.phpt b/ext/standard/tests/filters/convert.phpt
--- a/ext/standard/tests/filters/convert.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/filters/convert.phpt	2025-10-25 03:24:13.172502490 +0000
@@ -0,0 +1,130 @@
+--TEST--
+convert stream filter tests
+--FILE--
+<?php
+
+$text = "Hello World!";
+$binary = "ABC\xFF";
+
+function test_roundtrip($data, $encode, $decode, $opts = null, $is_binary = false) {
+    echo "Filter: $encode\n";
+
+    $fp = tmpfile();
+    fwrite($fp, $data);
+    rewind($fp);
+
+    if ($opts === null) {
+        stream_filter_prepend($fp, $encode, STREAM_FILTER_READ);
+    } else {
+        stream_filter_prepend($fp, $encode, STREAM_FILTER_READ, $opts);
+    }
+    $encoded = stream_get_contents($fp);
+    fclose($fp);
+
+    if ($is_binary) {
+        echo "Original (hex): " . bin2hex($data) . "\n";
+        echo "Encoded: $encoded\n";
+    } else {
+        echo "Original: $data\n";
+        echo "Encoded: $encoded\n";
+    }
+
+    $fp2 = tmpfile();
+    fwrite($fp2, $encoded);
+    rewind($fp2);
+
+    if ($opts === null) {
+        stream_filter_prepend($fp2, $decode, STREAM_FILTER_READ);
+    } else {
+        stream_filter_prepend($fp2, $decode, STREAM_FILTER_READ, $opts);
+    }
+    $decoded = stream_get_contents($fp2);
+    fclose($fp2);
+
+    if ($is_binary) {
+        echo "Decoded (hex): " . bin2hex($decoded) . "\n";
+    } else {
+        echo "Decoded: $decoded\n";
+    }
+    var_dump($data === $decoded);
+    echo "\n";
+}
+
+test_roundtrip($text, "convert.base64-encode", "convert.base64-decode");
+test_roundtrip($binary, "convert.base64-encode", "convert.base64-decode", null, true);
+test_roundtrip("", "convert.base64-encode", "convert.base64-decode");
+test_roundtrip("A", "convert.base64-encode", "convert.base64-decode");
+
+test_roundtrip($text, "convert.quoted-printable-encode", "convert.quoted-printable-decode");
+test_roundtrip("Line1\r\nLine2", "convert.quoted-printable-encode", "convert.quoted-printable-decode");
+
+$opts = array('line-length' => 20, 'line-break-chars' => "\n");
+test_roundtrip("Long text that will be wrapped", "convert.base64-encode", "convert.base64-decode", $opts);
+
+$opts2 = array('binary' => true);
+test_roundtrip("Text\t\r\n", "convert.quoted-printable-encode", "convert.quoted-printable-decode", $opts2);
+
+$fp = tmpfile();
+fwrite($fp, "Test");
+rewind($fp);
+stream_filter_prepend($fp, 'convert.base64-encode', STREAM_FILTER_READ);
+$result = stream_get_contents($fp);
+fclose($fp);
+var_dump($result === base64_encode("Test"));
+
+?>
+--EXPECTF--
+Filter: convert.base64-encode
+Original: Hello World!
+Encoded: SGVsbG8gV29ybGQh
+Decoded: Hello World!
+bool(true)
+
+Filter: convert.base64-encode
+Original (hex): 414243ff
+Encoded: QUJD/w==
+Decoded (hex): 414243ff
+bool(true)
+
+Filter: convert.base64-encode
+Original: 
+Encoded: 
+Decoded: 
+bool(true)
+
+Filter: convert.base64-encode
+Original: A
+Encoded: QQ==
+Decoded: A
+bool(true)
+
+Filter: convert.quoted-printable-encode
+Original: Hello World!
+Encoded: Hello World!
+Decoded: Hello World!
+bool(true)
+
+Filter: convert.quoted-printable-encode
+Original: Line1
+Line2
+Encoded: Line1=0D=0ALine2
+Decoded: Line1
+Line2
+bool(true)
+
+Filter: convert.base64-encode
+Original: Long text that will be wrapped
+Encoded: TG9uZyB0ZXh0IHRoYXQg
+d2lsbCBiZSB3cmFwcGVk
+Decoded: Long text that will be wrapped
+bool(true)
+
+Filter: convert.quoted-printable-encode
+Original: Text	
+
+Encoded: Text=09=0D=0A
+Decoded: Text	
+
+bool(true)
+
+bool(true)
diff '--color=auto' -Naur a/ext/standard/tests/filters/gh17345.phpt b/ext/standard/tests/filters/gh17345.phpt
--- a/ext/standard/tests/filters/gh17345.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/filters/gh17345.phpt	2025-10-25 03:24:13.172566964 +0000
@@ -0,0 +1,49 @@
+--TEST--
+GH-17345 (Bug #35916 was not completely fixed)
+--FILE--
+<?php
+$file = __DIR__ . "/gh17345.txt";
+@unlink($file);
+
+class strtoupper_filter extends php_user_filter
+{
+    function filter($in, $out, &$consumed, $closing): int
+    {
+        while ($bucket=stream_bucket_make_writeable($in)) {
+            $bucket->data = strtoupper($bucket->data);
+            $consumed += $bucket->datalen;
+            stream_bucket_prepend($out, $bucket);
+            // Interleave new bucket
+            stream_bucket_prepend($out, clone $bucket);
+            stream_bucket_prepend($out, $bucket);
+        }
+        return PSFS_PASS_ON;
+    }
+
+    function onCreate(): bool
+    {
+        echo "fffffffffff\n";
+        return true;
+    }
+
+    function onClose(): void
+    {
+        echo "hello\n";
+    }
+}
+
+stream_filter_register("strtoupper", "strtoupper_filter");
+$fp=fopen($file, "w");
+stream_filter_append($fp,  "strtoupper");
+fread($fp, 1024);
+fwrite($fp, "Thank you\n");
+fclose($fp);
+readfile($file);
+unlink($file);
+?>
+--EXPECTF--
+fffffffffff
+
+Notice: fread(): Read of 8192 bytes failed with errno=9 Bad file descriptor in %s on line %d
+hello
+THANK YOU
diff '--color=auto' -Naur a/ext/standard/tests/general_functions/debug_zval_dump_gh19801_memory_leak.phpt b/ext/standard/tests/general_functions/debug_zval_dump_gh19801_memory_leak.phpt
--- a/ext/standard/tests/general_functions/debug_zval_dump_gh19801_memory_leak.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/general_functions/debug_zval_dump_gh19801_memory_leak.phpt	2025-10-25 03:24:13.172723372 +0000
@@ -0,0 +1,32 @@
+--TEST--
+GH-19801 (debug_zval_dump() leak with __debugInfo() that modifies circular references)
+--FILE--
+<?php
+
+$a = [
+    new class {
+        function __debugInfo() {
+            global $b;
+            $b->a = null;
+            gc_collect_cycles();
+            return [];
+        }
+    },
+];
+
+$b = new stdClass;
+$b->a = &$a;
+
+debug_zval_dump($b);
+?>
+--EXPECTF--
+object(stdClass)#2 (1) refcount(%d){
+  ["a"]=>
+  reference refcount(%d) {
+    array(1) packed refcount(%d){
+      [0]=>
+      object(class@anonymous)#1 (0) refcount(%d){
+      }
+    }
+  }
+}
diff '--color=auto' -Naur a/ext/standard/tests/general_functions/var_dump_gh19801_memory_leak.phpt b/ext/standard/tests/general_functions/var_dump_gh19801_memory_leak.phpt
--- a/ext/standard/tests/general_functions/var_dump_gh19801_memory_leak.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/general_functions/var_dump_gh19801_memory_leak.phpt	2025-10-25 03:24:13.172804194 +0000
@@ -0,0 +1,30 @@
+--TEST--
+GH-19801 (var_dump() memory leak with __debugInfo() that modifies circular references)
+--FILE--
+<?php
+
+$a = [
+    new class {
+        function __debugInfo() {
+            global $b;
+            $b->a = null;
+            gc_collect_cycles();
+            return [];
+        }
+    },
+];
+
+$b = new stdClass;
+$b->a = &$a;
+
+var_dump($b);
+?>
+--EXPECTF--
+object(stdClass)#2 (1) {
+  ["a"]=>
+  &array(1) {
+    [0]=>
+    object(class@anonymous)#1 (0) {
+    }
+  }
+}
diff '--color=auto' -Naur a/ext/standard/tests/serialize/gh12265b.phpt b/ext/standard/tests/serialize/gh12265b.phpt
--- a/ext/standard/tests/serialize/gh12265b.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/serialize/gh12265b.phpt	2025-10-25 03:24:13.173050503 +0000
@@ -0,0 +1,48 @@
+--TEST--
+GH-12265 (Cloning an object breaks serialization recursion) - __sleep variation
+--FILE--
+<?php
+
+class A {
+    public function __construct(public B $x) {
+    }
+}
+
+class B {
+    public A $a;
+
+    public function __sleep()
+    {
+        $this->a = new A($this);
+        return ['a'];
+    }
+}
+
+class C {
+    public B $b;
+
+    public function __construct() {
+        $this->b = new B;
+    }
+}
+
+$b = new B();
+$sb = serialize($b);
+$stb = serialize(new B);
+
+printf("serialized original:    %s\n", $sb);
+printf("serialized temp    :    %s\n", $stb);
+
+$c = new C;
+$sc = serialize($c);
+$stc = serialize(new C);
+
+printf("serialized original:    %s\n", $sc);
+printf("serialized temp    :    %s\n", $stc);
+
+?>
+--EXPECT--
+serialized original:    O:1:"B":1:{s:1:"a";O:1:"A":1:{s:1:"x";r:1;}}
+serialized temp    :    O:1:"B":1:{s:1:"a";O:1:"A":1:{s:1:"x";r:1;}}
+serialized original:    O:1:"C":1:{s:1:"b";O:1:"B":1:{s:1:"a";O:1:"A":1:{s:1:"x";r:2;}}}
+serialized temp    :    O:1:"C":1:{s:1:"b";O:1:"B":1:{s:1:"a";O:1:"A":1:{s:1:"x";r:2;}}}
diff '--color=auto' -Naur a/ext/standard/tests/serialize/gh12265.phpt b/ext/standard/tests/serialize/gh12265.phpt
--- a/ext/standard/tests/serialize/gh12265.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/serialize/gh12265.phpt	2025-10-25 03:24:13.172972217 +0000
@@ -0,0 +1,47 @@
+--TEST--
+GH-12265 (Cloning an object breaks serialization recursion) - __serialize variation
+--FILE--
+<?php
+
+class A {
+    public function __construct(public B $x) {
+    }
+}
+
+class B {
+    public A $a;
+
+    public function __serialize()
+    {
+        return ['a' => new A($this)];
+    }
+}
+
+class C {
+    public B $b;
+
+    public function __construct() {
+        $this->b = new B;
+    }
+}
+
+$b = new B();
+$sb = serialize($b);
+$stb = serialize(new B);
+
+printf("serialized original:    %s\n", $sb);
+printf("serialized temp    :    %s\n", $stb);
+
+$c = new C;
+$sc = serialize($c);
+$stc = serialize(new C);
+
+printf("serialized original:    %s\n", $sc);
+printf("serialized temp    :    %s\n", $stc);
+
+?>
+--EXPECT--
+serialized original:    O:1:"B":1:{s:1:"a";O:1:"A":1:{s:1:"x";r:1;}}
+serialized temp    :    O:1:"B":1:{s:1:"a";O:1:"A":1:{s:1:"x";r:1;}}
+serialized original:    O:1:"C":1:{s:1:"b";O:1:"B":1:{s:1:"a";O:1:"A":1:{s:1:"x";r:2;}}}
+serialized temp    :    O:1:"C":1:{s:1:"b";O:1:"B":1:{s:1:"a";O:1:"A":1:{s:1:"x";r:2;}}}
diff '--color=auto' -Naur a/ext/standard/tests/serialize/gh19701.phpt b/ext/standard/tests/serialize/gh19701.phpt
--- a/ext/standard/tests/serialize/gh19701.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/serialize/gh19701.phpt	2025-10-25 03:24:13.173166015 +0000
@@ -0,0 +1,30 @@
+--TEST--
+GH-19701 (Serialize/deserialize loses some data)
+--CREDITS--
+cuchac
+DanielEScherzer
+--FILE--
+<?php
+
+class Item {
+    public $children = [];
+    public $parent = null;
+
+    public function __sleep() {
+        return ["children", "parent"];
+    }
+}
+
+$baseProduct = new Item();
+
+$child = new Item();
+$child->parent = $baseProduct;
+$baseProduct->children = [ $child ];
+
+$data = [clone $baseProduct, $baseProduct];
+
+echo serialize($data), "\n";
+
+?>
+--EXPECT--
+a:2:{i:0;O:4:"Item":2:{s:8:"children";a:1:{i:0;O:4:"Item":2:{s:8:"children";a:0:{}s:6:"parent";O:4:"Item":2:{s:8:"children";a:1:{i:0;r:4;}s:6:"parent";N;}}}s:6:"parent";N;}i:1;r:6;}
diff '--color=auto' -Naur a/ext/standard/tests/streams/gh19570.phpt b/ext/standard/tests/streams/gh19570.phpt
--- a/ext/standard/tests/streams/gh19570.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/streams/gh19570.phpt	2025-10-25 03:24:13.173305028 +0000
@@ -0,0 +1,22 @@
+--TEST--
+GH-19570 (unable to fseek in /dev/zero and /dev/null)
+--SKIPIF--
+<?php
+if (PHP_OS_FAMILY !== "Linux") die("skip only for Linux");
+?>
+--FILE--
+<?php
+$devices = [
+    // Note: could test others but they're not necessarily available
+    "/dev/zero",
+    "/dev/null",
+    "/dev/full",
+];
+foreach ($devices as $device) {
+    var_dump(fseek(fopen($device, "rb"), 1*1024*1024, SEEK_SET));
+}
+?>
+--EXPECT--
+int(0)
+int(0)
+int(0)
diff '--color=auto' -Naur a/ext/standard/tests/streams/gh19705.phpt b/ext/standard/tests/streams/gh19705.phpt
--- a/ext/standard/tests/streams/gh19705.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/standard/tests/streams/gh19705.phpt	2025-10-25 03:24:13.173379365 +0000
@@ -0,0 +1,11 @@
+--TEST--
+GH-19705 segmentation fault with non writable stream at stream_filter_append call.
+--EXTENSIONS--
+zlib
+--FILE--
+<?php
+$fh = fopen('data://text/plain,', 'w+',);
+var_dump(stream_filter_append($fh, 'zlib.deflate',STREAM_FILTER_WRITE));
+?>
+--EXPECTF--
+resource(%d) of type (stream filter)
diff '--color=auto' -Naur a/ext/standard/user_filters.c b/ext/standard/user_filters.c
--- a/ext/standard/user_filters.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/standard/user_filters.c	2025-10-25 03:24:13.173548103 +0000
@@ -408,17 +408,19 @@
 		memcpy(bucket->buf, Z_STRVAL_P(pzdata), bucket->buflen);
 	}
 
+	/* If the bucket is already on a brigade we have to unlink it first to keep the
+	 * linked list consistent. Furthermore, we can transfer the refcount in that case. */
+	if (bucket->brigade) {
+		php_stream_bucket_unlink(bucket);
+	} else {
+		bucket->refcount++;
+	}
+
 	if (append) {
 		php_stream_bucket_append(brigade, bucket);
 	} else {
 		php_stream_bucket_prepend(brigade, bucket);
 	}
-	/* This is a hack necessary to accommodate situations where bucket is appended to the stream
- 	 * multiple times. See bug35916.phpt for reference.
-	 */
-	if (bucket->refcount == 1) {
-		bucket->refcount++;
-	}
 }
 /* }}} */
 
diff '--color=auto' -Naur a/ext/standard/var.c b/ext/standard/var.c
--- a/ext/standard/var.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/standard/var.c	2025-10-25 03:24:13.173740594 +0000
@@ -153,7 +153,7 @@
 			} ZEND_HASH_FOREACH_END();
 			if (!(GC_FLAGS(myht) & GC_IMMUTABLE)) {
 				GC_UNPROTECT_RECURSION(myht);
-				GC_DELREF(myht);
+				GC_DTOR_NO_REF(myht);
 			}
 			if (level > 1) {
 				php_printf("%*c", level-1, ' ');
@@ -354,7 +354,7 @@
 		} ZEND_HASH_FOREACH_END();
 		if (!(GC_FLAGS(myht) & GC_IMMUTABLE)) {
 			GC_UNPROTECT_RECURSION(myht);
-			GC_DELREF(myht);
+			GC_DTOR_NO_REF(myht);
 		}
 		if (level > 1) {
 			php_printf("%*c", level - 1, ' ');
@@ -737,7 +737,10 @@
 		return 0;
 	} else if (!in_rcn_array
 	 && Z_REFCOUNT_P(var) == 1
-	 && (Z_OBJ_P(var)->properties == NULL || GC_REFCOUNT(Z_OBJ_P(var)->properties) == 1)) {
+	 && (Z_OBJ_P(var)->properties == NULL || GC_REFCOUNT(Z_OBJ_P(var)->properties) == 1)
+	 /* __serialize and __sleep may arbitrarily increase the refcount */
+	 && Z_OBJCE_P(var)->__serialize == NULL
+	 && zend_hash_find_known_hash(&Z_OBJCE_P(var)->function_table, ZSTR_KNOWN(ZEND_STR_SLEEP)) == NULL) {
 		return 0;
 	}
 
@@ -998,18 +1001,11 @@
 			/* we should still add element even if it's not OK,
 			 * since we already wrote the length of the array before */
 			if (Z_TYPE_P(data) == IS_ARRAY) {
-				if (UNEXPECTED(Z_IS_RECURSIVE_P(data))
-					|| UNEXPECTED(Z_TYPE_P(struc) == IS_ARRAY && Z_ARR_P(data) == Z_ARR_P(struc))) {
+				if (UNEXPECTED(Z_TYPE_P(struc) == IS_ARRAY && Z_ARR_P(data) == Z_ARR_P(struc))) {
 					php_add_var_hash(var_hash, struc, in_rcn_array);
 					smart_str_appendl(buf, "N;", 2);
 				} else {
-					if (Z_REFCOUNTED_P(data)) {
-						Z_PROTECT_RECURSION_P(data);
-					}
 					php_var_serialize_intern(buf, data, var_hash, in_rcn_array, false);
-					if (Z_REFCOUNTED_P(data)) {
-						Z_UNPROTECT_RECURSION_P(data);
-					}
 				}
 			} else {
 				php_var_serialize_intern(buf, data, var_hash, in_rcn_array, false);
diff '--color=auto' -Naur a/ext/xmlreader/php_xmlreader.c b/ext/xmlreader/php_xmlreader.c
--- a/ext/xmlreader/php_xmlreader.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/xmlreader/php_xmlreader.c	2025-10-25 03:24:13.174094916 +0000
@@ -542,6 +542,7 @@
 
 			RETURN_TRUE;
 		} else {
+			xmlRelaxNGFree(schema);
 			php_error_docref(NULL, E_WARNING, "Schema contains errors");
 			RETURN_FALSE;
 		}
diff '--color=auto' -Naur a/ext/xsl/tests/gh19988.phpt b/ext/xsl/tests/gh19988.phpt
--- a/ext/xsl/tests/gh19988.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/xsl/tests/gh19988.phpt	2025-10-25 03:24:13.174271691 +0000
@@ -0,0 +1,19 @@
+--TEST--
+GH-19988 (zend_string_init with NULL pointer in simplexml (UB))
+--EXTENSIONS--
+simplexml
+xsl
+--CREDITS--
+YuanchengJiang
+--FILE--
+<?php
+$sxe = simplexml_load_file(__DIR__ . '/53965/collection.xml');
+$processor = new XSLTProcessor;
+$dom = new DOMDocument;
+$dom->load(__DIR__ . '/53965/collection.xsl');
+$processor->importStylesheet($dom);
+$result = $processor->transformToDoc($sxe, SimpleXMLElement::class);
+var_dump($result->getName());
+?>
+--EXPECT--
+string(0) ""
diff '--color=auto' -Naur a/ext/zend_test/observer.c b/ext/zend_test/observer.c
--- a/ext/zend_test/observer.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/zend_test/observer.c	2025-10-25 03:24:13.174372308 +0000
@@ -155,7 +155,7 @@
 			php_printf("%*s<!-- init %s() -->\n", 2 * ZT_G(observer_nesting_depth), "", ZSTR_VAL(fbc->common.function_name));
 		}
 	} else {
-		php_printf("%*s<!-- init '%s' -->\n", 2 * ZT_G(observer_nesting_depth), "", ZSTR_VAL(fbc->op_array.filename));
+		php_printf("%*s<!-- init '%s' -->\n", 2 * ZT_G(observer_nesting_depth), "", fbc->op_array.filename ? ZSTR_VAL(fbc->op_array.filename) : "[no active file]");
 	}
 }
 
@@ -178,7 +178,7 @@
 				php_printf("%*s%s()\n", indent, "", ZSTR_VAL(fbc->common.function_name));
 			}
 		} else {
-			php_printf("%*s{main} %s\n", indent, "", ZSTR_VAL(fbc->op_array.filename));
+			php_printf("%*s{main} %s\n", indent, "", fbc->op_array.filename ? ZSTR_VAL(fbc->op_array.filename) : "[no active file]");
 		}
 	} while ((ex = ex->prev_execute_data) != NULL);
 	php_printf("%*s-->\n", 2 * ZT_G(observer_nesting_depth), "");
diff '--color=auto' -Naur a/ext/zend_test/test_arginfo.h b/ext/zend_test/test_arginfo.h
